/*
 *  Copyright (C) 2015  Thadeu Lima de Souza Cascardo <cascardo@cascardo.eti.br>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include "cmd.h"
#include "declaracao.h"
#include "contribuinte.h"
#include "util.h"

#define SET_INT_CONTRIBUINTE(attr) \
	SET_INT_(attr, attr, contribuinte.attr)

#define SET_STRING_CONTRIBUINTE(attr) \
	SET_STRING_(attr, attr, contribuinte.attr)

SET_STRING_CONTRIBUINTE(uf);
SET_INT_CONTRIBUINTE(cd_municipio);
SET_STRING_CONTRIBUINTE(municipio);
SET_STRING_CONTRIBUINTE(cep);
SET_STRING_CONTRIBUINTE(bairro);
SET_STRING_CONTRIBUINTE(tipo_logradouro);
SET_STRING_CONTRIBUINTE(logradouro);
SET_STRING_CONTRIBUINTE(numero);
SET_STRING_CONTRIBUINTE(complemento);
SET_STRING_CONTRIBUINTE(titulo_eleitor);
SET_STRING_CONTRIBUINTE(dn);
SET_STRING_CONTRIBUINTE(ddd);
SET_STRING_CONTRIBUINTE(telefone);
SET_INT_CONTRIBUINTE(natureza_ocupacao);
SET_INT_CONTRIBUINTE(ocupacao_principal);

void contribuinte_salva(struct declaracao *dec, FILE *f)
{
#define SALVA_STRING(attr) \
	if (dec->contribuinte.attr) \
		fprintf(f, #attr " \"%s\"\n", dec->contribuinte.attr);
#define SALVA_INT(attr) \
	fprintf(f, #attr " %d\n", dec->contribuinte.attr);
	SALVA_STRING(uf);
	SALVA_INT(cd_municipio);
	SALVA_STRING(municipio);
	SALVA_STRING(cep);
	SALVA_STRING(bairro);
	SALVA_STRING(tipo_logradouro);
	SALVA_STRING(logradouro);
	SALVA_STRING(numero);
	SALVA_STRING(complemento);
	SALVA_STRING(titulo_eleitor);
	SALVA_STRING(dn);
	SALVA_STRING(ddd);
	SALVA_STRING(telefone);
	SALVA_INT(natureza_ocupacao);
	SALVA_INT(ocupacao_principal);
}

int contribuinte_cmd_init(void)
{
	cmd_add(&cmd_uf);
	cmd_add(&cmd_cd_municipio);
	cmd_add(&cmd_municipio);
	cmd_add(&cmd_cep);
	cmd_add(&cmd_bairro);
	cmd_add(&cmd_tipo_logradouro);
	cmd_add(&cmd_logradouro);
	cmd_add(&cmd_numero);
	cmd_add(&cmd_complemento);
	cmd_add(&cmd_titulo_eleitor);
	cmd_add(&cmd_dn);
	cmd_add(&cmd_ddd);
	cmd_add(&cmd_telefone);
	cmd_add(&cmd_natureza_ocupacao);
	cmd_add(&cmd_ocupacao_principal);
	return 0;
}
